import  java.io.*;
import  java.util.Scanner;
import  java.util.*;

class node { 
   String info; 
   node next; 
} 

public class RecOrderedLinkedList { 

  public static String readInfo () {
    Scanner in = new Scanner(System.in);    
    System.out.print("Insert value: ");
    String info = in.next();
    return info;
  }
 
  public static void init (node lis) {
    lis = null;
  }

  public static boolean isEmpty (node lis) { 
      return (lis == null);
  }
  
    // recursive version
  public static int search(node lis, String s) { 
    if (lis == null || s.compareTo(lis.info)<0) { 
      return -1;
    }
    else if (s.compareTo(lis.info)==0) { 
      return 1;
    }
    else {
        int res = search(lis.next,s);
        if (res==-1) 
	    return -1;
        else 
            return 1+res;
    }  
  } 

    // recursive version
  public static node insert(node lis, String s) { 
    node p = new node();  
    p.info = s; 
    if (isEmpty(lis) || s.compareTo(lis.info) <= 0) {
      p.next=lis;
      lis = p;
      return lis;
    }
    else {
        lis.next=insert(lis.next,s);
	return lis; 
    }
  } 


    // recursive version
  public static node delete(node lis, String s) { 
    if (lis == null || s.compareTo(lis.info)<0) 
       return lis;
    if (lis.info.equals(s))
       return lis.next;
    lis.next = delete(lis.next,s);
    return lis;
  }

    // recursive version
  public static void print(node lis) { 
    if (lis == null) 
      System.out.println(); 
    else { 
      System.out.printf(" %s ", lis.info); 
      print(lis.next);
    }     
  } 

  
  public static void main(String args[]) {
      Scanner in = new Scanner(System.in);  
      node lis= null;
      String info = null;
      int pos = -1;

      char option = 'a';
      String opt = null;
      init(lis);
      do {
	    System.out.println("Options:");
	    System.out.println(" e: check if the list is empty");
	    System.out.println(" i: insert new element");
	    System.out.println(" r: delete the first element with info");
	    System.out.println(" s: search an element");
	    System.out.println(" p: print list");
          opt = in.next(); option = opt.charAt(0);
          switch (option) {
	    case 'e': 
	      if (isEmpty(lis))
                 System.out.println("The list is empty");
              else
                 System.out.println("The list is not empty");
		break;
	    case 'i': 
              info = readInfo();
              lis=insert(lis,info);
		break;
	    case 'r': 
              info = readInfo();
              lis= delete(lis,info);
		break;
	    case 's': 
              info = readInfo();
              pos= search(lis,info);
              if (pos==-1)
                 System.out.println("Not found");
              else
                 System.out.printf("Found in the %d-th position\n",pos);
		break;
	    case 'p': 
              print(lis);
		break;
	    }
	} while (
         option == 'e' || 
         option == 'i' || 
         option == 'r' || 
         option == 's' || 
         option == 'p' 
        );
  }
}  
